#ifndef INCLUDED_COM_SUN_STAR_CONTAINER_XENUMERATIONACCESS_HPP
#define INCLUDED_COM_SUN_STAR_CONTAINER_XENUMERATIONACCESS_HPP

#include "sal/config.h"

#include "com/sun/star/container/XEnumerationAccess.hdl"

#include "com/sun/star/uno/RuntimeException.hpp"
#include "com/sun/star/container/XElementAccess.hpp"
#include "com/sun/star/container/XEnumeration.hpp"
#include "com/sun/star/uno/Reference.hxx"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"

namespace com { namespace sun { namespace star { namespace container {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::container::XEnumerationAccess const *) {
    static ::com::sun::star::uno::Type * the_pType = 0;
    if (the_pType == 0)
    {
        ::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
        if (the_pType == 0)
        {
            ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.container.XEnumerationAccess") );

            // Start inline typedescription generation
            typelib_InterfaceTypeDescription * pTD = 0;

            typelib_TypeDescriptionReference * aSuperTypes[1];
            aSuperTypes[0] = ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::container::XElementAccess > >::get().getTypeLibType();
            typelib_TypeDescriptionReference * pMembers[1] = { 0 };
            ::rtl::OUString sMethodName0( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.container.XEnumerationAccess::createEnumeration") );
            typelib_typedescriptionreference_new( &pMembers[0],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName0.pData );

            typelib_typedescription_newMIInterface(
                &pTD,
                sTypeName.pData, 0x00000000, 0x0000, 0x0000, 0x00000000, 0x00000000,
                1, aSuperTypes,
                1,
                pMembers );

            typelib_typedescription_register( (typelib_TypeDescription**)&pTD );
            typelib_typedescriptionreference_release( pMembers[0] );
            typelib_typedescription_release( (typelib_TypeDescription*)pTD );

            static ::com::sun::star::uno::Type the_staticType( ::com::sun::star::uno::TypeClass_INTERFACE, sTypeName );
            the_pType = &the_staticType;
            ::cppu::UnoType< ::com::sun::star::uno::RuntimeException >::get();
            ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::container::XEnumeration > >::get();

            typelib_InterfaceMethodTypeDescription * pMethod = 0;
            {
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData };
                ::rtl::OUString sReturnType0( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.container.XEnumeration") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    5, sal_False,
                    sMethodName0.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE, sReturnType0.pData,
                    0, 0,
                    1, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            typelib_typedescription_release( (typelib_TypeDescription*)pMethod );
            // End inline typedescription generation
        }
    }

    return *the_pType;
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::uno::Reference< ::com::sun::star::container::XEnumerationAccess > const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::container::XEnumerationAccess > >::get();
}

::com::sun::star::uno::Type const & ::com::sun::star::container::XEnumerationAccess::static_type(void *) {
    return ::getCppuType(static_cast< ::com::sun::star::uno::Reference< ::com::sun::star::container::XEnumerationAccess > * >(0));
}

#endif // INCLUDED_COM_SUN_STAR_CONTAINER_XENUMERATIONACCESS_HPP
