#ifndef INCLUDED_COM_SUN_STAR_LANG_EVENTOBJECT_HPP
#define INCLUDED_COM_SUN_STAR_LANG_EVENTOBJECT_HPP

#include "sal/config.h"

#include "com/sun/star/lang/EventObject.hdl"

#include "com/sun/star/uno/XInterface.hpp"
#include "com/sun/star/uno/Reference.hxx"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/doublecheckedlocking.h"
#include "osl/mutex.hxx"
#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "sal/types.h"
#include "typelib/typeclass.h"
#include "typelib/typedescription.h"

namespace com { namespace sun { namespace star { namespace lang {

inline EventObject::EventObject() SAL_THROW( () )
    : Source()
{
}

inline EventObject::EventObject(const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Source_) SAL_THROW( () )
    : Source(Source_)
{
}

} } } }

namespace com { namespace sun { namespace star { namespace lang {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::lang::EventObject const *) {
    static ::com::sun::star::uno::Type * the_pType = 0;
    if (the_pType == 0) {
        ::osl::MutexGuard the_guard(::osl::Mutex::getGlobalMutex());
        if (the_pType == 0) {
            ::rtl::OUString the_name(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.lang.EventObject"));
            ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > >::get();
            ::rtl::OUString the_tname0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.XInterface"));
            ::rtl::OUString the_name0(RTL_CONSTASCII_USTRINGPARAM("Source"));
            ::typelib_StructMember_Init the_members[] = {
                { { typelib_TypeClass_INTERFACE, the_tname0.pData, the_name0.pData }, false } };
            ::typelib_TypeDescription * the_newType = 0;
            ::typelib_typedescription_newStruct(&the_newType, the_name.pData, 0, 1, the_members);
            ::typelib_typedescription_register(&the_newType);
            ::typelib_typedescription_release(the_newType);
            static ::com::sun::star::uno::Type the_staticType(::com::sun::star::uno::TypeClass_STRUCT, the_name);
            OSL_DOUBLE_CHECKED_LOCKING_MEMORY_BARRIER();
            the_pType = &the_staticType;
        }
    } else {
        OSL_DOUBLE_CHECKED_LOCKING_MEMORY_BARRIER();
    }
    return *the_pType;
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::lang::EventObject const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::lang::EventObject >::get();
}

#endif // INCLUDED_COM_SUN_STAR_LANG_EVENTOBJECT_HPP
