#ifndef INCLUDED_COM_SUN_STAR_REGISTRY_REGISTRYKEYTYPE_HPP
#define INCLUDED_COM_SUN_STAR_REGISTRY_REGISTRYKEYTYPE_HPP

#include "sal/config.h"

#include "com/sun/star/registry/RegistryKeyType.hdl"

#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"

namespace com { namespace sun { namespace star { namespace registry {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::registry::RegistryKeyType const *) {
    static ::com::sun::star::uno::Type * the_pType = 0;
    if (the_pType == 0)
    {
        ::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
        if (the_pType == 0)
        {
            ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.RegistryKeyType") );

            // Start inline typedescription generation
            typelib_TypeDescription * pTD = 0;

            rtl_uString* enumValueNames[2];
            ::rtl::OUString sEnumValue0( RTL_CONSTASCII_USTRINGPARAM("KEY") );
            enumValueNames[0] = sEnumValue0.pData;
            ::rtl::OUString sEnumValue1( RTL_CONSTASCII_USTRINGPARAM("LINK") );
            enumValueNames[1] = sEnumValue1.pData;

            sal_Int32 enumValues[2];
            enumValues[0] = 0;
            enumValues[1] = 1;

            typelib_typedescription_newEnum( &pTD,
                sTypeName.pData,
                (sal_Int32)::com::sun::star::registry::RegistryKeyType_KEY,
                2, enumValueNames, enumValues );

            typelib_typedescription_register( (typelib_TypeDescription**)&pTD );
            typelib_typedescription_release( pTD );
            // End inline typedescription generation

            static ::com::sun::star::uno::Type the_staticType( ::com::sun::star::uno::TypeClass_ENUM, sTypeName );
            the_pType = &the_staticType;
        }
    }

    return *the_pType;
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::registry::RegistryKeyType const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::registry::RegistryKeyType >::get();
}

#endif // INCLUDED_COM_SUN_STAR_REGISTRY_REGISTRYKEYTYPE_HPP
