#ifndef INCLUDED_COM_SUN_STAR_REGISTRY_XSIMPLEREGISTRY_HPP
#define INCLUDED_COM_SUN_STAR_REGISTRY_XSIMPLEREGISTRY_HPP

#include "sal/config.h"

#include "com/sun/star/registry/XSimpleRegistry.hdl"

#include "com/sun/star/registry/MergeConflictException.hpp"
#include "com/sun/star/registry/XRegistryKey.hpp"
#include "com/sun/star/uno/RuntimeException.hpp"
#include "com/sun/star/registry/InvalidRegistryException.hpp"
#include "com/sun/star/uno/XInterface.hpp"
#include "com/sun/star/uno/Reference.hxx"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"
#include "rtl/ustring.hxx"
#include "sal/types.h"

namespace com { namespace sun { namespace star { namespace registry {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::registry::XSimpleRegistry const *) {
    static ::com::sun::star::uno::Type * the_pType = 0;
    if (the_pType == 0)
    {
        ::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
        if (the_pType == 0)
        {
            ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XSimpleRegistry") );

            // Start inline typedescription generation
            typelib_InterfaceTypeDescription * pTD = 0;

            typelib_TypeDescriptionReference * aSuperTypes[1];
            aSuperTypes[0] = ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > >::get().getTypeLibType();
            typelib_TypeDescriptionReference * pMembers[8] = { 0,0,0,0,0,0,0,0 };
            ::rtl::OUString sMethodName0( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XSimpleRegistry::getURL") );
            typelib_typedescriptionreference_new( &pMembers[0],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName0.pData );
            ::rtl::OUString sMethodName1( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XSimpleRegistry::open") );
            typelib_typedescriptionreference_new( &pMembers[1],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName1.pData );
            ::rtl::OUString sMethodName2( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XSimpleRegistry::isValid") );
            typelib_typedescriptionreference_new( &pMembers[2],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName2.pData );
            ::rtl::OUString sMethodName3( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XSimpleRegistry::close") );
            typelib_typedescriptionreference_new( &pMembers[3],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName3.pData );
            ::rtl::OUString sMethodName4( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XSimpleRegistry::destroy") );
            typelib_typedescriptionreference_new( &pMembers[4],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName4.pData );
            ::rtl::OUString sMethodName5( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XSimpleRegistry::getRootKey") );
            typelib_typedescriptionreference_new( &pMembers[5],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName5.pData );
            ::rtl::OUString sMethodName6( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XSimpleRegistry::isReadOnly") );
            typelib_typedescriptionreference_new( &pMembers[6],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName6.pData );
            ::rtl::OUString sMethodName7( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XSimpleRegistry::mergeKey") );
            typelib_typedescriptionreference_new( &pMembers[7],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName7.pData );

            typelib_typedescription_newMIInterface(
                &pTD,
                sTypeName.pData, 0x00000000, 0x0000, 0x0000, 0x00000000, 0x00000000,
                1, aSuperTypes,
                8,
                pMembers );

            typelib_typedescription_register( (typelib_TypeDescription**)&pTD );
            typelib_typedescriptionreference_release( pMembers[0] );
            typelib_typedescriptionreference_release( pMembers[1] );
            typelib_typedescriptionreference_release( pMembers[2] );
            typelib_typedescriptionreference_release( pMembers[3] );
            typelib_typedescriptionreference_release( pMembers[4] );
            typelib_typedescriptionreference_release( pMembers[5] );
            typelib_typedescriptionreference_release( pMembers[6] );
            typelib_typedescriptionreference_release( pMembers[7] );
            typelib_typedescription_release( (typelib_TypeDescription*)pTD );

            static ::com::sun::star::uno::Type the_staticType( ::com::sun::star::uno::TypeClass_INTERFACE, sTypeName );
            the_pType = &the_staticType;
            ::cppu::UnoType< ::com::sun::star::uno::RuntimeException >::get();
            ::cppu::UnoType< ::com::sun::star::registry::InvalidRegistryException >::get();
            ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey > >::get();
            ::cppu::UnoType< ::com::sun::star::registry::MergeConflictException >::get();

            typelib_InterfaceMethodTypeDescription * pMethod = 0;
            {
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData };
                ::rtl::OUString sReturnType0( RTL_CONSTASCII_USTRINGPARAM("string") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    3, sal_False,
                    sMethodName0.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING, sReturnType0.pData,
                    0, 0,
                    1, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            {
                typelib_Parameter_Init aParameters[3];
                ::rtl::OUString sParamName0( RTL_CONSTASCII_USTRINGPARAM("rURL") );
                ::rtl::OUString sParamType0( RTL_CONSTASCII_USTRINGPARAM("string") );
                aParameters[0].pParamName = sParamName0.pData;
                aParameters[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
                aParameters[0].pTypeName = sParamType0.pData;
                aParameters[0].bIn = sal_True;
                aParameters[0].bOut = sal_False;
                ::rtl::OUString sParamName1( RTL_CONSTASCII_USTRINGPARAM("bReadOnly") );
                ::rtl::OUString sParamType1( RTL_CONSTASCII_USTRINGPARAM("boolean") );
                aParameters[1].pParamName = sParamName1.pData;
                aParameters[1].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_BOOLEAN;
                aParameters[1].pTypeName = sParamType1.pData;
                aParameters[1].bIn = sal_True;
                aParameters[1].bOut = sal_False;
                ::rtl::OUString sParamName2( RTL_CONSTASCII_USTRINGPARAM("bCreate") );
                ::rtl::OUString sParamType2( RTL_CONSTASCII_USTRINGPARAM("boolean") );
                aParameters[2].pParamName = sParamName2.pData;
                aParameters[2].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_BOOLEAN;
                aParameters[2].pTypeName = sParamType2.pData;
                aParameters[2].bIn = sal_True;
                aParameters[2].bOut = sal_False;
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.InvalidRegistryException"));
                ::rtl::OUString the_ExceptionName1(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData, the_ExceptionName1.pData };
                ::rtl::OUString sReturnType1( RTL_CONSTASCII_USTRINGPARAM("void") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    4, sal_False,
                    sMethodName1.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_VOID, sReturnType1.pData,
                    3, aParameters,
                    2, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            {
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData };
                ::rtl::OUString sReturnType2( RTL_CONSTASCII_USTRINGPARAM("boolean") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    5, sal_False,
                    sMethodName2.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_BOOLEAN, sReturnType2.pData,
                    0, 0,
                    1, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            {
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.InvalidRegistryException"));
                ::rtl::OUString the_ExceptionName1(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData, the_ExceptionName1.pData };
                ::rtl::OUString sReturnType3( RTL_CONSTASCII_USTRINGPARAM("void") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    6, sal_False,
                    sMethodName3.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_VOID, sReturnType3.pData,
                    0, 0,
                    2, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            {
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.InvalidRegistryException"));
                ::rtl::OUString the_ExceptionName1(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData, the_ExceptionName1.pData };
                ::rtl::OUString sReturnType4( RTL_CONSTASCII_USTRINGPARAM("void") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    7, sal_False,
                    sMethodName4.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_VOID, sReturnType4.pData,
                    0, 0,
                    2, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            {
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.InvalidRegistryException"));
                ::rtl::OUString the_ExceptionName1(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData, the_ExceptionName1.pData };
                ::rtl::OUString sReturnType5( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XRegistryKey") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    8, sal_False,
                    sMethodName5.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE, sReturnType5.pData,
                    0, 0,
                    2, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            {
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.InvalidRegistryException"));
                ::rtl::OUString the_ExceptionName1(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData, the_ExceptionName1.pData };
                ::rtl::OUString sReturnType6( RTL_CONSTASCII_USTRINGPARAM("boolean") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    9, sal_False,
                    sMethodName6.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_BOOLEAN, sReturnType6.pData,
                    0, 0,
                    2, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            {
                typelib_Parameter_Init aParameters[2];
                ::rtl::OUString sParamName0( RTL_CONSTASCII_USTRINGPARAM("aKeyName") );
                ::rtl::OUString sParamType0( RTL_CONSTASCII_USTRINGPARAM("string") );
                aParameters[0].pParamName = sParamName0.pData;
                aParameters[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
                aParameters[0].pTypeName = sParamType0.pData;
                aParameters[0].bIn = sal_True;
                aParameters[0].bOut = sal_False;
                ::rtl::OUString sParamName1( RTL_CONSTASCII_USTRINGPARAM("aUrl") );
                ::rtl::OUString sParamType1( RTL_CONSTASCII_USTRINGPARAM("string") );
                aParameters[1].pParamName = sParamName1.pData;
                aParameters[1].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
                aParameters[1].pTypeName = sParamType1.pData;
                aParameters[1].bIn = sal_True;
                aParameters[1].bOut = sal_False;
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.InvalidRegistryException"));
                ::rtl::OUString the_ExceptionName1(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.MergeConflictException"));
                ::rtl::OUString the_ExceptionName2(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData, the_ExceptionName1.pData, the_ExceptionName2.pData };
                ::rtl::OUString sReturnType7( RTL_CONSTASCII_USTRINGPARAM("void") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    10, sal_False,
                    sMethodName7.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_VOID, sReturnType7.pData,
                    2, aParameters,
                    3, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            typelib_typedescription_release( (typelib_TypeDescription*)pMethod );
            // End inline typedescription generation
        }
    }

    return *the_pType;
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::uno::Reference< ::com::sun::star::registry::XSimpleRegistry > const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::registry::XSimpleRegistry > >::get();
}

::com::sun::star::uno::Type const & ::com::sun::star::registry::XSimpleRegistry::static_type(void *) {
    return ::getCppuType(static_cast< ::com::sun::star::uno::Reference< ::com::sun::star::registry::XSimpleRegistry > * >(0));
}

#endif // INCLUDED_COM_SUN_STAR_REGISTRY_XSIMPLEREGISTRY_HPP
