#ifndef INCLUDED_COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP
#define INCLUDED_COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP

#include "sal/config.h"

#include "com/sun/star/lang/XMultiServiceFactory.hdl"

#include "com/sun/star/uno/RuntimeException.hpp"
#include "com/sun/star/uno/Exception.hpp"
#include "com/sun/star/uno/XInterface.hpp"
#include "com/sun/star/uno/Any.hxx"
#include "com/sun/star/uno/Reference.hxx"
#include "com/sun/star/uno/Sequence.hxx"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"
#include "rtl/ustring.hxx"

namespace com { namespace sun { namespace star { namespace lang {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::lang::XMultiServiceFactory const *) {
    static ::com::sun::star::uno::Type * the_pType = 0;
    if (the_pType == 0)
    {
        ::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
        if (the_pType == 0)
        {
            ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.lang.XMultiServiceFactory") );

            // Start inline typedescription generation
            typelib_InterfaceTypeDescription * pTD = 0;

            typelib_TypeDescriptionReference * aSuperTypes[1];
            aSuperTypes[0] = ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > >::get().getTypeLibType();
            typelib_TypeDescriptionReference * pMembers[3] = { 0,0,0 };
            ::rtl::OUString sMethodName0( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.lang.XMultiServiceFactory::createInstance") );
            typelib_typedescriptionreference_new( &pMembers[0],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName0.pData );
            ::rtl::OUString sMethodName1( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.lang.XMultiServiceFactory::createInstanceWithArguments") );
            typelib_typedescriptionreference_new( &pMembers[1],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName1.pData );
            ::rtl::OUString sMethodName2( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.lang.XMultiServiceFactory::getAvailableServiceNames") );
            typelib_typedescriptionreference_new( &pMembers[2],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName2.pData );

            typelib_typedescription_newMIInterface(
                &pTD,
                sTypeName.pData, 0x00000000, 0x0000, 0x0000, 0x00000000, 0x00000000,
                1, aSuperTypes,
                3,
                pMembers );

            typelib_typedescription_register( (typelib_TypeDescription**)&pTD );
            typelib_typedescriptionreference_release( pMembers[0] );
            typelib_typedescriptionreference_release( pMembers[1] );
            typelib_typedescriptionreference_release( pMembers[2] );
            typelib_typedescription_release( (typelib_TypeDescription*)pTD );

            static ::com::sun::star::uno::Type the_staticType( ::com::sun::star::uno::TypeClass_INTERFACE, sTypeName );
            the_pType = &the_staticType;
            ::cppu::UnoType< ::com::sun::star::uno::RuntimeException >::get();
            ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > >::get();
            ::cppu::UnoType< ::com::sun::star::uno::Exception >::get();
            ::cppu::UnoType< ::cppu::UnoSequenceType< ::com::sun::star::uno::Any > >::get();
            ::cppu::UnoType< ::cppu::UnoSequenceType< ::rtl::OUString > >::get();

            typelib_InterfaceMethodTypeDescription * pMethod = 0;
            {
                typelib_Parameter_Init aParameters[1];
                ::rtl::OUString sParamName0( RTL_CONSTASCII_USTRINGPARAM("aServiceSpecifier") );
                ::rtl::OUString sParamType0( RTL_CONSTASCII_USTRINGPARAM("string") );
                aParameters[0].pParamName = sParamName0.pData;
                aParameters[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
                aParameters[0].pTypeName = sParamType0.pData;
                aParameters[0].bIn = sal_True;
                aParameters[0].bOut = sal_False;
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.Exception"));
                ::rtl::OUString the_ExceptionName1(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData, the_ExceptionName1.pData };
                ::rtl::OUString sReturnType0( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.XInterface") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    3, sal_False,
                    sMethodName0.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE, sReturnType0.pData,
                    1, aParameters,
                    2, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            {
                typelib_Parameter_Init aParameters[2];
                ::rtl::OUString sParamName0( RTL_CONSTASCII_USTRINGPARAM("ServiceSpecifier") );
                ::rtl::OUString sParamType0( RTL_CONSTASCII_USTRINGPARAM("string") );
                aParameters[0].pParamName = sParamName0.pData;
                aParameters[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
                aParameters[0].pTypeName = sParamType0.pData;
                aParameters[0].bIn = sal_True;
                aParameters[0].bOut = sal_False;
                ::rtl::OUString sParamName1( RTL_CONSTASCII_USTRINGPARAM("Arguments") );
                ::rtl::OUString sParamType1( RTL_CONSTASCII_USTRINGPARAM("[]any") );
                aParameters[1].pParamName = sParamName1.pData;
                aParameters[1].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_SEQUENCE;
                aParameters[1].pTypeName = sParamType1.pData;
                aParameters[1].bIn = sal_True;
                aParameters[1].bOut = sal_False;
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.Exception"));
                ::rtl::OUString the_ExceptionName1(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData, the_ExceptionName1.pData };
                ::rtl::OUString sReturnType1( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.XInterface") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    4, sal_False,
                    sMethodName1.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE, sReturnType1.pData,
                    2, aParameters,
                    2, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            {
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData };
                ::rtl::OUString sReturnType2( RTL_CONSTASCII_USTRINGPARAM("[]string") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    5, sal_False,
                    sMethodName2.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_SEQUENCE, sReturnType2.pData,
                    0, 0,
                    1, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            typelib_typedescription_release( (typelib_TypeDescription*)pMethod );
            // End inline typedescription generation
        }
    }

    return *the_pType;
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > >::get();
}

::com::sun::star::uno::Type const & ::com::sun::star::lang::XMultiServiceFactory::static_type(void *) {
    return ::getCppuType(static_cast< ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > * >(0));
}

#endif // INCLUDED_COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP
