#ifndef INCLUDED_COM_SUN_STAR_LOADER_XIMPLEMENTATIONLOADER_HPP
#define INCLUDED_COM_SUN_STAR_LOADER_XIMPLEMENTATIONLOADER_HPP

#include "sal/config.h"

#include "com/sun/star/loader/XImplementationLoader.hdl"

#include "com/sun/star/registry/CannotRegisterImplementationException.hpp"
#include "com/sun/star/registry/XRegistryKey.hpp"
#include "com/sun/star/uno/RuntimeException.hpp"
#include "com/sun/star/loader/CannotActivateFactoryException.hpp"
#include "com/sun/star/uno/XInterface.hpp"
#include "com/sun/star/uno/Reference.hxx"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"
#include "rtl/ustring.hxx"
#include "sal/types.h"

namespace com { namespace sun { namespace star { namespace loader {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::loader::XImplementationLoader const *) {
    static ::com::sun::star::uno::Type * the_pType = 0;
    if (the_pType == 0)
    {
        ::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
        if (the_pType == 0)
        {
            ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.loader.XImplementationLoader") );

            // Start inline typedescription generation
            typelib_InterfaceTypeDescription * pTD = 0;

            typelib_TypeDescriptionReference * aSuperTypes[1];
            aSuperTypes[0] = ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > >::get().getTypeLibType();
            typelib_TypeDescriptionReference * pMembers[2] = { 0,0 };
            ::rtl::OUString sMethodName0( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.loader.XImplementationLoader::activate") );
            typelib_typedescriptionreference_new( &pMembers[0],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName0.pData );
            ::rtl::OUString sMethodName1( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.loader.XImplementationLoader::writeRegistryInfo") );
            typelib_typedescriptionreference_new( &pMembers[1],
                                                  (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE_METHOD,
                                                  sMethodName1.pData );

            typelib_typedescription_newMIInterface(
                &pTD,
                sTypeName.pData, 0x00000000, 0x0000, 0x0000, 0x00000000, 0x00000000,
                1, aSuperTypes,
                2,
                pMembers );

            typelib_typedescription_register( (typelib_TypeDescription**)&pTD );
            typelib_typedescriptionreference_release( pMembers[0] );
            typelib_typedescriptionreference_release( pMembers[1] );
            typelib_typedescription_release( (typelib_TypeDescription*)pTD );

            static ::com::sun::star::uno::Type the_staticType( ::com::sun::star::uno::TypeClass_INTERFACE, sTypeName );
            the_pType = &the_staticType;
            ::cppu::UnoType< ::com::sun::star::uno::RuntimeException >::get();
            ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > >::get();
            ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey > >::get();
            ::cppu::UnoType< ::com::sun::star::loader::CannotActivateFactoryException >::get();
            ::cppu::UnoType< ::com::sun::star::registry::CannotRegisterImplementationException >::get();

            typelib_InterfaceMethodTypeDescription * pMethod = 0;
            {
                typelib_Parameter_Init aParameters[4];
                ::rtl::OUString sParamName0( RTL_CONSTASCII_USTRINGPARAM("implementationName") );
                ::rtl::OUString sParamType0( RTL_CONSTASCII_USTRINGPARAM("string") );
                aParameters[0].pParamName = sParamName0.pData;
                aParameters[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
                aParameters[0].pTypeName = sParamType0.pData;
                aParameters[0].bIn = sal_True;
                aParameters[0].bOut = sal_False;
                ::rtl::OUString sParamName1( RTL_CONSTASCII_USTRINGPARAM("implementationLoaderUrl") );
                ::rtl::OUString sParamType1( RTL_CONSTASCII_USTRINGPARAM("string") );
                aParameters[1].pParamName = sParamName1.pData;
                aParameters[1].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
                aParameters[1].pTypeName = sParamType1.pData;
                aParameters[1].bIn = sal_True;
                aParameters[1].bOut = sal_False;
                ::rtl::OUString sParamName2( RTL_CONSTASCII_USTRINGPARAM("locationUrl") );
                ::rtl::OUString sParamType2( RTL_CONSTASCII_USTRINGPARAM("string") );
                aParameters[2].pParamName = sParamName2.pData;
                aParameters[2].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
                aParameters[2].pTypeName = sParamType2.pData;
                aParameters[2].bIn = sal_True;
                aParameters[2].bOut = sal_False;
                ::rtl::OUString sParamName3( RTL_CONSTASCII_USTRINGPARAM("xKey") );
                ::rtl::OUString sParamType3( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XRegistryKey") );
                aParameters[3].pParamName = sParamName3.pData;
                aParameters[3].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE;
                aParameters[3].pTypeName = sParamType3.pData;
                aParameters[3].bIn = sal_True;
                aParameters[3].bOut = sal_False;
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.loader.CannotActivateFactoryException"));
                ::rtl::OUString the_ExceptionName1(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData, the_ExceptionName1.pData };
                ::rtl::OUString sReturnType0( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.XInterface") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    3, sal_False,
                    sMethodName0.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE, sReturnType0.pData,
                    4, aParameters,
                    2, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            {
                typelib_Parameter_Init aParameters[3];
                ::rtl::OUString sParamName0( RTL_CONSTASCII_USTRINGPARAM("xKey") );
                ::rtl::OUString sParamType0( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.XRegistryKey") );
                aParameters[0].pParamName = sParamName0.pData;
                aParameters[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE;
                aParameters[0].pTypeName = sParamType0.pData;
                aParameters[0].bIn = sal_True;
                aParameters[0].bOut = sal_False;
                ::rtl::OUString sParamName1( RTL_CONSTASCII_USTRINGPARAM("implementationLoaderUrl") );
                ::rtl::OUString sParamType1( RTL_CONSTASCII_USTRINGPARAM("string") );
                aParameters[1].pParamName = sParamName1.pData;
                aParameters[1].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
                aParameters[1].pTypeName = sParamType1.pData;
                aParameters[1].bIn = sal_True;
                aParameters[1].bOut = sal_False;
                ::rtl::OUString sParamName2( RTL_CONSTASCII_USTRINGPARAM("locationUrl") );
                ::rtl::OUString sParamType2( RTL_CONSTASCII_USTRINGPARAM("string") );
                aParameters[2].pParamName = sParamName2.pData;
                aParameters[2].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
                aParameters[2].pTypeName = sParamType2.pData;
                aParameters[2].bIn = sal_True;
                aParameters[2].bOut = sal_False;
                ::rtl::OUString the_ExceptionName0(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.CannotRegisterImplementationException"));
                ::rtl::OUString the_ExceptionName1(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
                rtl_uString * the_Exceptions[] = { the_ExceptionName0.pData, the_ExceptionName1.pData };
                ::rtl::OUString sReturnType1( RTL_CONSTASCII_USTRINGPARAM("boolean") );
                typelib_typedescription_newInterfaceMethod( &pMethod,
                    4, sal_False,
                    sMethodName1.pData,
                    (typelib_TypeClass)::com::sun::star::uno::TypeClass_BOOLEAN, sReturnType1.pData,
                    3, aParameters,
                    2, the_Exceptions );
                typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
            }
            typelib_typedescription_release( (typelib_TypeDescription*)pMethod );
            // End inline typedescription generation
        }
    }

    return *the_pType;
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::uno::Reference< ::com::sun::star::loader::XImplementationLoader > const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::loader::XImplementationLoader > >::get();
}

::com::sun::star::uno::Type const & ::com::sun::star::loader::XImplementationLoader::static_type(void *) {
    return ::getCppuType(static_cast< ::com::sun::star::uno::Reference< ::com::sun::star::loader::XImplementationLoader > * >(0));
}

#endif // INCLUDED_COM_SUN_STAR_LOADER_XIMPLEMENTATIONLOADER_HPP
