#ifndef INCLUDED_COM_SUN_STAR_REGISTRY_REGISTRYVALUETYPE_HPP
#define INCLUDED_COM_SUN_STAR_REGISTRY_REGISTRYVALUETYPE_HPP

#include "sal/config.h"

#include "com/sun/star/registry/RegistryValueType.hdl"

#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"

namespace com { namespace sun { namespace star { namespace registry {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::registry::RegistryValueType const *) {
    static ::com::sun::star::uno::Type * the_pType = 0;
    if (the_pType == 0)
    {
        ::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
        if (the_pType == 0)
        {
            ::rtl::OUString sTypeName( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.registry.RegistryValueType") );

            // Start inline typedescription generation
            typelib_TypeDescription * pTD = 0;

            rtl_uString* enumValueNames[8];
            ::rtl::OUString sEnumValue0( RTL_CONSTASCII_USTRINGPARAM("NOT_DEFINED") );
            enumValueNames[0] = sEnumValue0.pData;
            ::rtl::OUString sEnumValue1( RTL_CONSTASCII_USTRINGPARAM("LONG") );
            enumValueNames[1] = sEnumValue1.pData;
            ::rtl::OUString sEnumValue2( RTL_CONSTASCII_USTRINGPARAM("ASCII") );
            enumValueNames[2] = sEnumValue2.pData;
            ::rtl::OUString sEnumValue3( RTL_CONSTASCII_USTRINGPARAM("STRING") );
            enumValueNames[3] = sEnumValue3.pData;
            ::rtl::OUString sEnumValue4( RTL_CONSTASCII_USTRINGPARAM("BINARY") );
            enumValueNames[4] = sEnumValue4.pData;
            ::rtl::OUString sEnumValue5( RTL_CONSTASCII_USTRINGPARAM("LONGLIST") );
            enumValueNames[5] = sEnumValue5.pData;
            ::rtl::OUString sEnumValue6( RTL_CONSTASCII_USTRINGPARAM("ASCIILIST") );
            enumValueNames[6] = sEnumValue6.pData;
            ::rtl::OUString sEnumValue7( RTL_CONSTASCII_USTRINGPARAM("STRINGLIST") );
            enumValueNames[7] = sEnumValue7.pData;

            sal_Int32 enumValues[8];
            enumValues[0] = 0;
            enumValues[1] = 1;
            enumValues[2] = 2;
            enumValues[3] = 3;
            enumValues[4] = 4;
            enumValues[5] = 5;
            enumValues[6] = 6;
            enumValues[7] = 7;

            typelib_typedescription_newEnum( &pTD,
                sTypeName.pData,
                (sal_Int32)::com::sun::star::registry::RegistryValueType_NOT_DEFINED,
                8, enumValueNames, enumValues );

            typelib_typedescription_register( (typelib_TypeDescription**)&pTD );
            typelib_typedescription_release( pTD );
            // End inline typedescription generation

            static ::com::sun::star::uno::Type the_staticType( ::com::sun::star::uno::TypeClass_ENUM, sTypeName );
            the_pType = &the_staticType;
        }
    }

    return *the_pType;
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::registry::RegistryValueType const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::registry::RegistryValueType >::get();
}

#endif // INCLUDED_COM_SUN_STAR_REGISTRY_REGISTRYVALUETYPE_HPP
